use iced::subscription::{Subscription, channel};

#[derive(Debug, Clone, PartialEq)]
pub enum AppWebsocketState {
    Disconnected,
    Connected
}

#[derive(Debug, Clone, PartialEq)]
pub struct AppWebsocketConfig {
    host: String,
    user: Option<String>,
    pass: Option<String>
}

impl AppWebsocketConfig {
    pub fn new(host: String, user: Option<String>, pass: Option<String>) -> Self {
        Self {
            host,
            user,
            pass
        }
    }
}

pub fn websocket(config: AppWebsocketConfig) -> Subscription<super::ChatAppEvent> {
    struct Websocket;

    channel(
        std::any::TypeId::of::<Websocket>(),
        100,
        |mut output| async move {
            let mut state = AppWebsocketState::Disconnected;

            loop {

            }
        }
    )
}
